<?php
namespace App\Controllers\Configuracion;


use App\Controllers\BaseResourceController;

use App\Models\Collection;

use App\Entities\Configuracion\MaquinasTarifasImpresionEntity;

use App\Models\Configuracion\MaquinasTarifasImpresionModel;

use App\Models\Configuracion\MaquinaModel;

use
DataTables\Editor,
DataTables\Editor\Field;

class Maquinastarifasimpresion extends \App\Controllers\BaseResourceController
{

    protected $modelName = MaquinasTarifasImpresionModel::class;
    protected $format = 'json';

    protected static $singularObjectName = 'Maquinas Tarifa Impresion';
    protected static $singularObjectNameCc = 'maquinasTarifaImpresion';
    protected static $pluralObjectName = 'Maquinas Tarifas Impresion';
    protected static $pluralObjectNameCc = 'maquinasTarifasImpresion';

    protected static $controllerSlug = 'maquinastarifasimpresion';

    protected static $viewPath = 'themes/vuexy/form/configuracion/maquinas/';

    protected $indexRoute = 'maquinasTarifaImpresionList';


    public function initController(\CodeIgniter\HTTP\RequestInterface $request, \CodeIgniter\HTTP\ResponseInterface $response, \Psr\Log\LoggerInterface $logger)
    {
        $this->viewData['pageTitle'] = lang('MaquinasTarifasImpresions.moduleTitle');
        $this->viewData['usingSweetAlert'] = true;

        // Se indica que este controlador trabaja con soft_delete
        $this->soft_delete = true;
        // Se indica el flag para los ficheros borrados
        $this->delete_flag = 1;


        parent::initController($request, $response, $logger);
    }


    public function index()
    {

        $viewData = [
            'currentModule' => static::$controllerSlug,
            'pageSubTitle' => lang('Basic.global.ManageAllRecords', [lang('MaquinasTarifasImpresions.maquinasTarifaImpresion')]),
            'maquinasTarifasImpresion' => new MaquinasTarifasImpresion(),
            'usingServerSideDataTable' => true,

        ];

        $viewData = array_merge($this->viewData, $viewData); // merge any possible values from the parent controller class

        return view(static::$viewPath . 'viewMaquinasTarifaImpresionList', $viewData);
    }


    public function add()
    {




        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);


            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->save($sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['errorMessage'] = lang('Basic.global.formErr1', [lang('Basic.global.record')]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());
                endif;

                $thenRedirect = true;  // Change this to false if you want your user to stay on the form after submission
            endif;
            if ($noException && $successfulResult):

                $id = $this->model->db->insertID();

                $message = lang('Basic.global.saveSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult

        endif; // ($requestMethod === 'post')

        $this->viewData['maquinasTarifasImpresion'] = isset($sanitizedData) ? new MaquinasTarifasImpresion($sanitizedData) : new MaquinasTarifasImpresion();
        $this->viewData['maquinaList'] = $this->getMaquinaListItems($maquinasTarifasImpresion->maquina_id ?? null);
        $this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('createMaquinasTarifaImpresion');

        $this->viewData['boxTitle'] = lang('Basic.global.addNew') . ' ' . lang('MaquinasTarifasImpresions.moduleTitle') . ' ' . lang('Basic.global.addNewSuffix');


        return $this->displayForm(__METHOD__);
    } // end function add()


    public function edit($requestedId = null)
    {

        if ($requestedId == null):
            return $this->redirect2listView();
        endif;
        $id = filter_var($requestedId, FILTER_SANITIZE_URL);
        $maquinasTarifasImpresion = $this->model->find($id);

        if ($maquinasTarifasImpresion == false):
            $message = lang('Basic.global.notFoundWithIdErr', [mb_strtolower(lang('MaquinasTarifasImpresions.maquinasTarifaImpresion')), $id]);
            return $this->redirect2listView('sweet-error', $message);
        endif;



        if ($this->request->getPost()):

            $nullIfEmpty = true; // !(phpversion() >= '8.1');

            $postData = $this->request->getPost();

            $sanitizedData = $this->sanitized($postData, $nullIfEmpty);
            if ($this->request->getPost('predeterminado') == null) {
                $sanitizedData['predeterminado'] = false;
            }


            $noException = true;
            if ($successfulResult = $this->canValidate()): // if ($successfulResult = $this->validate($this->formValidationRules) ) :


                if ($this->canValidate()):
                    try {
                        $successfulResult = $this->model->skipValidation(true)->update($id, $sanitizedData);
                    } catch (\Exception $e) {
                        $noException = false;
                        $this->dealWithException($e);
                    }
                else:
                    $this->viewData['warningMessage'] = lang('Basic.global.formErr1', [mb_strtolower(lang('MaquinasTarifasImpresions.maquinasTarifaImpresion'))]);
                    $this->session->setFlashdata('formErrors', $this->model->errors());

                endif;

                $maquinasTarifasImpresion->fill($sanitizedData);

                $thenRedirect = false;
            endif;
            if ($noException && $successfulResult):
                $id = $maquinasTarifasImpresion->id ?? $id;
                $message = lang('Basic.global.updateSuccess', [lang('Basic.global.record')]) . '.';

                if ($thenRedirect):
                    if (!empty($this->indexRoute)):
                        return redirect()->to(route_to($this->indexRoute))->with('sweet-success', $message);
                    else:
                        return $this->redirect2listView('sweet-success', $message);
                    endif;
                else:
                    $this->session->setFlashData('sweet-success', $message);
                endif;

            endif; // $noException && $successfulResult
        endif; // ($requestMethod === 'post')

        $this->viewData['maquinasTarifasImpresion'] = $maquinasTarifasImpresion;
        $this->viewData['maquinaList'] = $this->getMaquinaListItems($maquinasTarifasImpresion->maquina_id ?? null);
        $this->viewData['tipoList'] = $this->getTipoOptions();

        $this->viewData['formAction'] = route_to('updateMaquinasTarifaImpresion', $id);

        $this->viewData['boxTitle'] = lang('Basic.global.edit2') . ' ' . lang('MaquinasTarifasImpresions.moduleTitle') . ' ' . lang('Basic.global.edit3');


        return $this->displayForm(__METHOD__, $id);
    } // end function edit(...)


    public function datatable_editor()
    {
        if ($this->request->isAJAX()) {

            include(APPPATH . "ThirdParty/DatatablesEditor/DataTables.php");

            // Build our Editor instance and process the data coming from _POST
            $response = Editor::inst($db, 'lg_maquinas_tarifas_impresion')
                ->fields(
                    Field::inst('uso')
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('MaquinasTarifasImpresions.validation.uso.required')
                            )
                        ),
                    Field::inst('tipo')
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('MaquinasTarifasImpresions.validation.tipo.required')
                            )
                        ),
                    Field::inst('precio')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('MaquinasTarifasImpresions.validation.precio.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('MaquinasTarifasImpresions.validation.tipo.required')
                            )
                        ),
                    Field::inst('margen')
                        ->getFormatter('Format::toDecimalChar')->setFormatter('Format::fromDecimalChar')
                        ->validator(
                            'Validate::numeric',
                            array(
                                "decimal" => ',',
                                'message' => lang('MaquinasTarifasImpresions.validation.precio.decimal')
                            )
                        )
                        ->validator(
                            'Validate::notEmpty',
                            array(
                                'message' => lang('MaquinasTarifasImpresions.validation.tipo.required')
                            )
                        ),
                    Field::inst('maquina_id'),
                    Field::inst('user_created_id'),
                    Field::inst('created_at'),
                    Field::inst('user_updated_id'),
                    Field::inst('updated_at'),
                    Field::inst('is_deleted'),
                    Field::inst('deleted_at'),

                )
                ->validator(function ($editor, $action, $data) {
                    if ($action === Editor::ACTION_CREATE || $action === Editor::ACTION_EDIT) {
                        foreach ($data['data'] as $pkey => $values) {
                            // Si no se quiere borrar...
                            if ($data['data'][$pkey]['is_deleted'] != 1) {
                                // Cubierta y sobrecubierta sólo pueden ser en color
                                if ($values['uso'] != 'interior' && $values['tipo'] != 'colorhq') {
                                    return lang('MaquinasTarifasImpresions.validation.cubierta_sobrecubierta_color');
                                }

                                $builder = $this->model->select('*')
                                    ->where(array(
                                        'maquina_id' => $values['maquina_id'],
                                        'tipo' => $values['tipo'],
                                        'uso' => $values['uso'],
                                        'is_deleted' => 0
                                    ));

                                $id = $builder->get()->getFirstRow();
                                if ($id) {
                                    $id = $id->id;
                                    // No se pueden duplicar valores al crear o al editar
                                    if ($builder->countAllResults() >= 1) {
                                        if (
                                            ($action === Editor::ACTION_EDIT && $id != $pkey)
                                            || $action === Editor::ACTION_CREATE
                                        ) {

                                            return lang('MaquinasTarifasImpresions.validation.duplicated_uso_tipo');
                                        }
                                    }
                                }
                            }
                        }
                    }
                })
                ->on('preCreate', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_created_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('created_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->on('preEdit', function ($editor, &$values) {
                    $session = session();
                    $datetime = (new \CodeIgniter\I18n\Time("now"));
                    $editor
                        ->field('user_updated_id')
                        ->setValue($session->id_user);
                    $editor
                        ->field('updated_at')
                        ->setValue($datetime->format('Y-m-d H:i:s'));
                })
                ->debug(true)
                ->process($_POST)
                ->data();


            /*// if unique key is set in DB
            if(isset($response['error'])){
                if(str_contains($response['error'], "tirada_min_tirada_max") &&
                str_contains($response['error'], "Duplicate entry ")){
                    $response['error'] = lang('TarifaAcabadoLineas.validation.duplicated_tirada'); 
                }
            }*/
            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();

            $response[$csrfTokenName] = $newTokenHash;

            echo json_encode($response);

        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function datatable()
    {
        if ($this->request->isAJAX()) {
            $reqData = $this->request->getPost();
            if (!isset($reqData['draw']) || !isset($reqData['columns'])) {
                $errstr = 'No data available in response to this specific request.';
                $response = $this->respond(Collection::datatable([], 0, 0, $errstr), 400, $errstr);
                return $response;
            }
            $start = $reqData['start'] ?? 0;
            $length = $reqData['length'] ?? 5;
            $search = $reqData['search']['value'];
            $requestedOrder = $reqData['order']['0']['column'] ?? 1;
            $order = MaquinasTarifasImpresionModel::SORTABLE[$requestedOrder > 0 ? $requestedOrder : 1];
            $dir = $reqData['order']['0']['dir'] ?? 'asc';

            $id_M = $reqData['id_maquina'] ?? -1;

            $resourceData = $this->model->getResource("", $id_M)->orderBy($order, $dir)->limit($length, $start)->get()->getResultObject();

            return $this->respond(Collection::datatable(
                $resourceData,
                $this->model->getResource()->countAllResults(),
                $this->model->getResource($search, $id_M)->countAllResults()
            ));
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function allItemsSelect()
    {
        if ($this->request->isAJAX()) {
            $onlyActiveOnes = true;
            $reqVal = $this->request->getPost('val') ?? 'id';
            $menu = $this->model->getAllForMenu($reqVal . ', maquina_id', 'maquina_id', $onlyActiveOnes, false);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->maquina_id = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }

    public function menuItems()
    {
        if ($this->request->isAJAX()) {
            $searchStr = goSanitize($this->request->getPost('searchTerm'))[0];
            $reqId = goSanitize($this->request->getPost('id'))[0];
            $reqText = goSanitize($this->request->getPost('text'))[0];
            $onlyActiveOnes = false;
            $columns2select = [$reqId ?? 'id', $reqText ?? 'maquina_id'];
            $onlyActiveOnes = false;
            $menu = $this->model->getSelect2MenuItems($columns2select, $columns2select[1], $onlyActiveOnes, $searchStr);
            $nonItem = new \stdClass;
            $nonItem->id = '';
            $nonItem->text = '- ' . lang('Basic.global.None') . ' -';
            array_unshift($menu, $nonItem);

            $newTokenHash = csrf_hash();
            $csrfTokenName = csrf_token();
            $data = [
                'menu' => $menu,
                $csrfTokenName => $newTokenHash
            ];
            return $this->respond($data);
        } else {
            return $this->failUnauthorized('Invalid request', 403);
        }
    }


    protected function getMaquinaListItems($selId = null)
    {
        $data = ['' => lang('Basic.global.pleaseSelectA', [mb_strtolower(lang('Maquinas.maquina'))])];
        if (!empty($selId)):
            $maquinaModel = model('App\Models\Configuracion\MaquinaModel');

            $selOption = $maquinaModel->where('id', $selId)->findColumn('nombre');
            if (!empty($selOption)):
                $data[$selId] = $selOption[0];
            endif;
        endif;
        return $data;
    }


    protected function getTipoOptions()
    {
        $tipoOptions = [
            '' => lang('Basic.global.pleaseSelect'),
            'negro' => 'negro',
            'color' => 'color',
            'negrohq' => 'negrohq',
            'bicolor' => 'bicolor',
            'colorhq' => 'colorhq',
        ];
        return $tipoOptions;
    }


}
